function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import getContext from "../../utils/miniRedux";
var defaultState = {
  // 表格id 用于缓存配置到localStorage
  tableId: "",
  // 是否使用本地数据模式
  localPagination: false,
  dataSource: [],
  // 原始数据 用于回显
  originDataSource: [],
  defaultColumns: [],
  // 原始列 用于列操作时还原
  originColumns: [],
  originColumnsMap: new Map(),
  currentCell: null,
  quickFilter: [],
  otherFilter: [],
  utils: {},
  isTerminal: false,
  setting: {
    field: {
      edit: 0
    },
    data: {
      edit: 0
    }
  },
  tableWidth: 700,
  // 当前页展示的数据
  currentDataSource: [],
  // 经过一系列格式化之后的所有数据
  originResultDataSource: []
};
var _getContext = getContext({
    namespace: "state",
    state: defaultState,
    reducers: {
      setDataSource: function setDataSource(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          dataSource: payload
        });
      },
      setOriginDataSource: function setOriginDataSource(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          originDataSource: payload
        });
      },
      setDefaultColumns: function setDefaultColumns(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          defaultColumns: payload.map(function (d) {
            return formatColumn(d);
          })
        });
      },
      setOriginColumns: function setOriginColumns(state, payload) {
        var originColumns = payload.map(function (d) {
          return formatColumn(d);
        });
        var originColumnsMap = new Map(originColumns.map(function (item) {
          return [item.key, item];
        }));
        return _objectSpread(_objectSpread({}, state), {}, {
          originColumns: originColumns,
          originColumnsMap: originColumnsMap
        });
      },
      setCurrentCell: function setCurrentCell(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          currentCell: payload
        });
      },
      setQuickFilter: function setQuickFilter(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          quickFilter: payload
        });
      },
      setUtils: function setUtils(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          utils: payload
        });
      },
      setIsTerminal: function setIsTerminal(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          isTerminal: payload
        });
      },
      syncStorage: function syncStorage(state, payload) {
        return _objectSpread({}, state);
      },
      init: function init(state, payload) {
        // 这里进行初始化, 比如 同步storage数据
        return _objectSpread({}, state);
      },
      setOtherFilter: function setOtherFilter(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          otherFilter: payload
        });
      },
      setTableId: function setTableId(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          tableId: payload
        });
      },
      setLocalPagination: function setLocalPagination(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          localPagination: payload
        });
      },
      setTableWidth: function setTableWidth(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          tableWidth: payload
        });
      },
      setCurrentDataSource: function setCurrentDataSource(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          currentDataSource: payload
        });
      },
      setOriginResultDataSource: function setOriginResultDataSource(state, payload) {
        return _objectSpread(_objectSpread({}, state), {}, {
          originResultDataSource: payload
        });
      }
    }
  }),
  Provider = _getContext.Provider,
  Context = _getContext.Context;
export { Provider, Context };
export var formatColumn = function formatColumn(item) {
  var _other = _objectSpread({
    editable: true,
    field_type: "text",
    lock: true
  }, item.other || {});
  return _objectSpread(_objectSpread({}, _other), item);
};